Subject: openvpn-auth-ldap: ftbfs with GCC-15

From: Matthias Klose <[email-masked]>
Date: Mon, 17 Feb 2025 17:41:51 +0000

Package: src:openvpn-auth-ldap
Version: 2.0.4-4
Severity: important
Tags: sid forky
User: [email-masked]
Usertags: ftbfs-gcc-15

[This bug is NOT targeted to the upcoming trixie release]

Please keep this issue open in the bug tracker for the package it
was filed for.  If a fix in another package is required, please
file a bug for the other package (or clone), and add a block in this
package. Please keep the issue open until the package can be built in
a follow-up test rebuild.

The package fails to build in a test rebuild on at least amd64 with
gcc-15/g++-15, but succeeds to build with gcc-14/g++-14. The
severity of this report will be raised before the forky release.

The full build log can be found at:
http://qa-logs.debian.net/2025/02/16/amd64exp/openvpn-auth-ldap_2.0.4-4_unstable_gccexp.log.gz
The last lines of the build log are at the end of this report.

To build with GCC 15, either set CC=gcc-15 CXX=g++-15 explicitly,
or install the gcc, g++, gfortran, ... packages from experimental.

  apt-get -t=experimental install g++ 

GCC 15 now defaults to the C23/C++23 standards, exposing many FTBFS.
Other Common build failures are new warnings resulting in build failures
with -Werror turned on, or new/dropped symbols in Debian symbols files.
For other C/C++ related build failures see the porting guide at
http://gcc.gnu.org/gcc-15/porting_to.html

[...]
config.status: creating Mk/compile.mk
config.status: creating Mk/subdir.mk
config.status: creating src/Makefile
config.status: creating tests/Makefile
config.status: creating tools/Makefile
config.status: creating config.h
make[1]: Leaving directory '/build/reproducible-path/openvpn-auth-ldap-2.0.4'
   dh_auto_build
	make -j8
make[1]: Entering directory '/build/reproducible-path/openvpn-auth-ldap-2.0.4'
===> making all in tools
make[2]: Entering directory '/build/reproducible-path/openvpn-auth-ldap-2.0.4/tools'
gcc -g -O2 -Werror=implicit-function-declaration -ffile-prefix-map=/build/reproducible-path/openvpn-auth-ldap-2.0.4=. -fstack-protector-strong -fstack-clash-protection -Wformat -Werror=format-security -fcf-protection -D_FORTIFY_SOURCE=2 -DHAVE_CONFIG_H -Wall -c lemon.c -o lemon.o -I. -I../src -I.. -I../src -I. -I../tests -I../tests
gcc -g -O2 -Werror=implicit-function-declaration -ffile-prefix-map=/build/reproducible-path/openvpn-auth-ldap-2.0.4=. -fstack-protector-strong -fstack-clash-protection -Wformat -Werror=format-security -fcf-protection -D_FORTIFY_SOURCE=2 -DHAVE_CONFIG_H -Wall -c makeheaders.c -o makeheaders.o -I. -I../src -I.. -I../src -I. -I../tests -I../tests
lemon.c:639:6: error: conflicting types for ‘FindRulePrecedences’; have ‘void(struct lemon *)’
  639 | void FindRulePrecedences(struct lemon *xp)
      |      ^~~~~~~~~~~~~~~~~~~
lemon.c:62:6: note: previous declaration of ‘FindRulePrecedences’ with type ‘void(void)’
   62 | void FindRulePrecedences();
      |      ^~~~~~~~~~~~~~~~~~~
lemon.c:668:6: error: conflicting types for ‘FindFirstSets’; have ‘void(struct lemon *)’
  668 | void FindFirstSets(struct lemon *lemp)
      |      ^~~~~~~~~~~~~
lemon.c:63:6: note: previous declaration of ‘FindFirstSets’ with type ‘void(void)’
   63 | void FindFirstSets();
      |      ^~~~~~~~~~~~~
lemon.c:731:6: error: conflicting types for ‘FindStates’; have ‘void(struct lemon *)’
  731 | void FindStates(struct lemon *lemp)
      |      ^~~~~~~~~~
lemon.c:64:6: note: previous declaration of ‘FindStates’ with type ‘void(void)’
   64 | void FindStates();
      |      ^~~~~~~~~~
lemon.c:903:6: error: conflicting types for ‘FindLinks’; have ‘void(struct lemon *)’
  903 | void FindLinks(struct lemon *lemp)
      |      ^~~~~~~~~
lemon.c:65:6: note: previous declaration of ‘FindLinks’ with type ‘void(void)’
   65 | void FindLinks();
      |      ^~~~~~~~~
lemon.c:938:6: error: conflicting types for ‘FindFollowSets’; have ‘void(struct lemon *)’
  938 | void FindFollowSets(struct lemon *lemp)
      |      ^~~~~~~~~~~~~~
lemon.c:66:6: note: previous declaration of ‘FindFollowSets’ with type ‘void(void)’
   66 | void FindFollowSets();
      |      ^~~~~~~~~~~~~~
lemon.c:974:6: error: conflicting types for ‘FindActions’; have ‘void(struct lemon *)’
  974 | void FindActions(struct lemon *lemp)
      |      ^~~~~~~~~~~
lemon.c:67:6: note: previous declaration of ‘FindActions’ with type ‘void(void)’
   67 | void FindActions();
      |      ^~~~~~~~~~~
make[2]: *** [../Mk/compile.mk:9: lemon.o] Error 1
make[2]: *** Waiting for unfinished jobs....
makeheaders.c: In function ‘GetBigToken’:
makeheaders.c:1107:15: warning: variable ‘z’ set but not used [-Wunused-but-set-variable]
 1107 |   const char *z, *zStart;
      |               ^
makeheaders.c: In function ‘ProcessMethodDef’:
makeheaders.c:1682:10: warning: variable ‘pCode’ set but not used [-Wunused-but-set-variable]
 1682 |   Token *pCode;
      |          ^~~~~
makeheaders.c: At top level:
makeheaders.c:1:19: warning: ‘ident’ defined but not used [-Wunused-const-variable=]
    1 | static const char ident[] = "@(#) $Header: /cvstrac/cvstrac/makeheaders.c,v 1.4 2005/03/16 22:17:51 drh Exp $";
      |                   ^~~~~
make[2]: Leaving directory '/build/reproducible-path/openvpn-auth-ldap-2.0.4/tools'
make[1]: *** [Mk/subdir.mk:8: all] Error 1
make[1]: Leaving directory '/build/reproducible-path/openvpn-auth-ldap-2.0.4'
dh_auto_build: error: make -j8 returned exit code 2
make: *** [debian/rules:7: binary] Error 25
dpkg-buildpackage: error: debian/rules binary subprocess returned exit status 2